<?php

namespace Drupal\freecaster\Plugin\video_embed_field\Provider;

use Drupal\video_embed_field\ProviderPluginBase;

/**
 * Freecaster video embed field provider.
 *
 * @VideoEmbedProvider(
 *   id = "freecaster",
 *   title = @Translation("Freecaster")
 * )
 */
class Freecaster extends ProviderPluginBase {

  /**
   * {@inheritdoc}
   */
  public function renderEmbedCode($width, $height, $autoplay) {
    return [
      '#type' => 'html_tag',
      '#tag' => 'iframe',
      '#attributes' => [
        'width' => $width,
        'height' => $height,
        'frameborder' => '0',
        'allowfullscreen' => 'allowfullscreen',
        'src' => sprintf('http://player.freecaster.com/embed/%s',
          $this->getVideoId()),
      ],
    ];
  }

  /**
   * {@inheritdoc}
   *
   * @TODO : Peut-on récupérer une Thumbnail URL depuis l'API ?
   */
  public function getRemoteThumbnailUrl() {
  }

  /**
   * {@inheritdoc}
   */
  public static function getIdFromInput($input) {
    $id = FALSE;
    // Parse_url is an easy way to break a url into its components.
    $parsed = parse_url($input);
    $path = $parsed['path'];
    $parts = explode('/', $path);
    $id = end($parts);
    return $id;
  }

}
